<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.2"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>VivianUI: TriLib.TransformExtensions Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">VivianUI
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.2 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('class_tri_lib_1_1_transform_extensions.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="class_tri_lib_1_1_transform_extensions-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">TriLib.TransformExtensions Class Reference</div></div>
</div><!--header-->
<div class="contents">

<p>Represents a series of UnityEngine.Transform extension methods.  
 <a href="class_tri_lib_1_1_transform_extensions.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-static-methods" name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ab5461ce1c46c8b0cca73cb78c39b98ab"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_tri_lib_1_1_transform_extensions.html#ab5461ce1c46c8b0cca73cb78c39b98ab">LoadMatrix</a> (this Transform transform, Matrix4x4 matrix, bool local=true)</td></tr>
<tr class="memdesc:ab5461ce1c46c8b0cca73cb78c39b98ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assigns a UnityEngine.Matrix4x4 into UnityEngine.Transform components.  <a href="class_tri_lib_1_1_transform_extensions.html#ab5461ce1c46c8b0cca73cb78c39b98ab">More...</a><br /></td></tr>
<tr class="separator:ab5461ce1c46c8b0cca73cb78c39b98ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca0039881574987675bb33c4a0d6a760"><td class="memItemLeft" align="right" valign="top">static Bounds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_tri_lib_1_1_transform_extensions.html#aca0039881574987675bb33c4a0d6a760">EncapsulateBounds</a> (this Transform transform)</td></tr>
<tr class="memdesc:aca0039881574987675bb33c4a0d6a760"><td class="mdescLeft">&#160;</td><td class="mdescRight">Encapsulates the UnityEngine.Transform childs bounds on new bounds.  <a href="class_tri_lib_1_1_transform_extensions.html#aca0039881574987675bb33c4a0d6a760">More...</a><br /></td></tr>
<tr class="separator:aca0039881574987675bb33c4a0d6a760"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3955be3d7e2f8829ff999b02acdcf311"><td class="memItemLeft" align="right" valign="top">static Transform&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_tri_lib_1_1_transform_extensions.html#a3955be3d7e2f8829ff999b02acdcf311">FindDeepChild</a> (this Transform transform, string name, bool endsWith=false)</td></tr>
<tr class="memdesc:a3955be3d7e2f8829ff999b02acdcf311"><td class="mdescLeft">&#160;</td><td class="mdescRight"> <a href="class_tri_lib_1_1_transform_extensions.html#a3955be3d7e2f8829ff999b02acdcf311">More...</a><br /></td></tr>
<tr class="separator:a3955be3d7e2f8829ff999b02acdcf311"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1ce4b2ac80b20f6673e5090ed345750"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_tri_lib_1_1_transform_extensions.html#ac1ce4b2ac80b20f6673e5090ed345750">DestroyChildren</a> (this Transform transform, bool destroyImmediate=false)</td></tr>
<tr class="memdesc:ac1ce4b2ac80b20f6673e5090ed345750"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroys the children UnityEngine.GameObject of this UnityEngine.Transform.  <a href="class_tri_lib_1_1_transform_extensions.html#ac1ce4b2ac80b20f6673e5090ed345750">More...</a><br /></td></tr>
<tr class="separator:ac1ce4b2ac80b20f6673e5090ed345750"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p >Represents a series of UnityEngine.Transform extension methods. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="ac1ce4b2ac80b20f6673e5090ed345750" name="ac1ce4b2ac80b20f6673e5090ed345750"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac1ce4b2ac80b20f6673e5090ed345750">&#9670;&nbsp;</a></span>DestroyChildren()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void TriLib.TransformExtensions.DestroyChildren </td>
          <td>(</td>
          <td class="paramtype">this Transform&#160;</td>
          <td class="paramname"><em>transform</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>destroyImmediate</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destroys the children UnityEngine.GameObject of this UnityEngine.Transform. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">transform</td><td>UnityEngine.Transform to destroy children from.</td></tr>
    <tr><td class="paramname">destroyImmediate</td><td>When <code>true</code> destroy children immediately.</td></tr>
  </table>
  </dd>
</dl>
<p><br  />
 </p>

</div>
</div>
<a id="aca0039881574987675bb33c4a0d6a760" name="aca0039881574987675bb33c4a0d6a760"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca0039881574987675bb33c4a0d6a760">&#9670;&nbsp;</a></span>EncapsulateBounds()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static Bounds TriLib.TransformExtensions.EncapsulateBounds </td>
          <td>(</td>
          <td class="paramtype">this Transform&#160;</td>
          <td class="paramname"><em>transform</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Encapsulates the UnityEngine.Transform childs bounds on new bounds. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">transform</td><td>UnityEngine.Transform to encapsulate.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Encapsulated UnityEngine.Bounds.</dd></dl>
<div class="fragment"><div class="line"><span class="comment">//Gets the bounds that represents all children extents</span></div>
<div class="line">var bounds = myTransform.EncapsulateBounds();</div>
<div class="line"><span class="comment">//Gets the bounds radius</span></div>
<div class="line">var boundRadius = bounds.extents.magnitude;</div>
<div class="line"><span class="comment">//Calculates a distance from &quot;myTransform&quot; for camera framing</span></div>
<div class="line">var distance = (boundRadius / (2.0f * Mathf.Tan(0.5f * camera.fieldOfView * Mathf.Deg2Rad))) * radius;</div>
<div class="line"><span class="comment">//Returns if the distance isn´t numeric (caused by empty bounds)</span></div>
<div class="line"><span class="keywordflow">if</span> (System.Single.IsNaN(distance))</div>
<div class="line">{</div>
<div class="line">    <span class="keywordflow">return</span>;</div>
<div class="line">}</div>
<div class="line"><span class="comment">//Sets the camera far clip plane to the double of the acquired distance </span></div>
<div class="line">camera.farClipPlane = distance * 2f;</div>
<div class="line"><span class="comment">//Puts the camera at the acquired distance relative to the bounds</span></div>
<div class="line">camera.transform.position = <span class="keyword">new</span> Vector3(bounds.center.x, bounds.center.y, bounds.center.z + distance);</div>
<div class="line"><span class="comment">//Looks at the bounds center with the camera</span></div>
<div class="line">camera.transform.LookAt(bounds.center);</div>
</div><!-- fragment --> 
</div>
</div>
<a id="a3955be3d7e2f8829ff999b02acdcf311" name="a3955be3d7e2f8829ff999b02acdcf311"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3955be3d7e2f8829ff999b02acdcf311">&#9670;&nbsp;</a></span>FindDeepChild()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static Transform TriLib.TransformExtensions.FindDeepChild </td>
          <td>(</td>
          <td class="paramtype">this Transform&#160;</td>
          <td class="paramname"><em>transform</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>endsWith</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p></p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">transform</td><td>UnityEngine.Transform to search in.</td></tr>
    <tr><td class="paramname">name</td><td>Name of the object to search for.</td></tr>
    <tr><td class="paramname">endsWith</td><td>When true, search for transforms that ends with 'name' value.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The UnityEngine.Transform if found, otherwise, null.</dd></dl>

</div>
</div>
<a id="ab5461ce1c46c8b0cca73cb78c39b98ab" name="ab5461ce1c46c8b0cca73cb78c39b98ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab5461ce1c46c8b0cca73cb78c39b98ab">&#9670;&nbsp;</a></span>LoadMatrix()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void TriLib.TransformExtensions.LoadMatrix </td>
          <td>(</td>
          <td class="paramtype">this Transform&#160;</td>
          <td class="paramname"><em>transform</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Matrix4x4&#160;</td>
          <td class="paramname"><em>matrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>local</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Assigns a UnityEngine.Matrix4x4 into UnityEngine.Transform components. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">transform</td><td>UnityEngine.Transform to assign the UnityEngine.Matrix4x4.</td></tr>
    <tr><td class="paramname">matrix</td><td>UnityEngine.Matrix4x4 to assign.</td></tr>
    <tr><td class="paramname">local</td><td>If true, copies the UnityEngine.Matrix4x4 components to UnityEngine.Transform local components. Otherwise, copies the UnityEngine.Matrix4x4 components to UnityEngine.Transform world components. </td></tr>
  </table>
  </dd>
</dl>
<div class="fragment"><div class="line"><span class="comment">//Creates a matrix that moves 100 units forward at world space, then rotates 90 units on y-axis at local space</span></div>
<div class="line">var myMatrix = Matrix4x4.TRS(<span class="keyword">new</span> Vector3(0f, 0f, 100f), Quaternion.Euler(0f, 90f, 0f), Vector3.one);</div>
<div class="line"><span class="comment">//Assigns the position, rotation and local scale contained in the &quot;myMatrix&quot; into &quot;myGameObject&quot;</span></div>
<div class="line">myGameObject.transform.LoadMatrix(myMatrix);</div>
</div><!-- fragment --> 
</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/home/chris/dev/unity/VivianUI/Assets/TriLib/TriLib/Scripts/Extensions/<a class="el" href="_transform_extensions_8cs.html">TransformExtensions.cs</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespace_tri_lib.html">TriLib</a></li><li class="navelem"><a class="el" href="class_tri_lib_1_1_transform_extensions.html">TransformExtensions</a></li>
    <li class="footer">Generated on Mon Dec 20 2021 15:24:23 for VivianUI by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.2 </li>
  </ul>
</div>
</body>
</html>
